READY/ READY	LD	SP,STACK
 	EI
 	LD	HL,RDY
 ;*****	READY/ASM
 	CALL	PRINT		;TO THE VIDEO
 	LD	HL,DOSBUF	;INPUT BUFFER
 	LD	B,255		;255 CHAR INPUT + ENTER
 	CALL	INPUT		;GET IT FROM KEYBOARD
 	JP	Z,NOTHIN	;NOTHING DONE
 DOSCNT	RST	8		;POSITION HL
 	JR	NC,DCONT
 	CP	13
 	JR	Z,READY		;TERMINATE STRING
 	INC	HL
 	JR	DOSCNT
 DCONT	LD	A,10H		;BRING IN SYS1
 	RST	28H		;LOAD IF NOT RESIDENT
 	LD	DE,LIBR		;LIBRARY COMMAND TABLE
 	RST	18H
 	LD	(BUFPNT),HL	;SAVE POINTER
 	JR	Z,NOLIB		;NOT A LIBRARY COMMAND
 	LD	HL,LOOKUP	;COMMAND TABLE
 	DEC	A		;ADJUST FOR TABLE
 	ADD	A,L
 	LD	L,A
 	LD	A,(HL)		;GET TABLE BYTE
 	LD	HL,(BUFPNT)	;GET POINTER BYTE
 	RST	28H		;EXECUTE COMMAND
 DOCONT	LD	HL,(BUFPNT)	;GET POINTER BACK
 CNTLOOP	LD	A,(HL)		;GET BYTE FROM STRING
 	CP	13		;TERMINATOR
 	JP	Z,DOSCNT	;CONTINUE IF YES
 	INC	HL		;BUMP POINTER
 	CP	';'		;SEPARATOR ?
 	JR	NZ,CNTLOOP	;GO ON
 	JP	DOSCNT		;CONTINUE
 NOLIB	LD	HL,NOLMSG	;MESSAGE
 	CALL	PRINT		;DISPLAY IT
 	LD	HL,(BUFPNT)	;GET COMMAND LINE
 	CALL	PRINT		;PRINT IT OUT
 	JP	READY		;TERMINATE COMMAND LINE
 NOLMSG	DB	'Invalid command.',13
 SYSDRV	DB	1		;DRIVE FOR SYSTEM OVERLAY
 OVERLAY	PUSH	HL		;SAVE REGISTERS
 	PUSH	DE
 	PUSH	AF
 	AND	0F0H		;MASK LOW 4 BITS OUT
 	JR	Z,OVLDON	;DONE IF TO SYS0
 	LD	HL,LAST		;SAVE NEW COMMAND
 	CP	(HL)		;SAME AS LAST REQUEST
 	JR	Z,OVLDON	;SKIP IF NOW IN MEM.
 	LD	HL,SYSTBL	;SYSTEM TABLE
 	SRL	A		;OVLAY * 16
 	SRL	A		; * 8
 	SRL	A		; * 4
 	DEC	A		;LESS 1 FOR TABLE
 	LD	E,A
 	LD	D,0		;DE=TABLE DISPLACEMENT
 	ADD	HL,DE		;POINT TO IT
 	LD	A,(HL)		;GET SYSTEM BYTE
 	OR	A		;SET FLAGS
 	JP	Z,NOSYS		;SYSTEM PROGRAM NOT FOUND
 	INC	HL		;POINT TO # SECTORS
 	LD	A,(HL)		;GET COUNT
 	INC	HL		;POINT TO START TRACK
 	LD	D,(HL)		;GET THAT
 	INC	HL		;POINT TO START SECTOR
 	LD	E,(HL)		;GET THAT TOO
 	LD	A,(SYSDRV)	;GET SYSTEM DRIVE
 	LD	(DRIV),A	;FOR SELECT DRIVE
 	CALL	MREAD		;MULTIPLE READ
 	POP	AF		;GET COMMAND
 	PUSH	AF		;PUT IT BACK
 	AND	0F0H		;NEW SYSTEM IN MEMORY
 	LD	(LAST),A	;SAVE FOR LATER
 OVLDON	POP	AF		;RESTORE REGISTERS
 	POP	DE
 	POP	HL
 	PUSH	AF		;RESAVE IT
 	AND	0FH		;GET COMMAND NUMBER
 	JR	NZ,EXECOV	;EXECUTE IF NOT 0
 	POP	AF		;OTHERWISE RETURN
 	RET			;COMMAND VALID IN A REG.
 EXECOV	POP	AF		;RESTORE COMMAND
 	JP	GODOS		;EXECUTE THE COMMAND
 PARSE	PUSH	BC		;SAVE COUNT
 	LD	B,1		;POSITION COUNT
 PARLP	LD	A,(DE)		;GET TABLE BYTE
 	BIT	7,A		;CHECK FOR COMMAND BEGIN
 	INC	DE		;BUMP TABLE
 	JR	Z,PARLP		;CONTINUE TILL FIRST BYTE
 	AND	7FH		;CLEAR HIGH BIT
 	JR	Z,PAREND	;END OF TABLE
 	LD	C,(HL)		;GET STRING BYTE
 	CP	C		;COMPARE
 	JR	Z,PARGOT	;MATCH
 	RES	5,C		;LOWERCASE OFF
 	CP	C		;SAME AS TABLE ?
 PARGOT	PUSH	HL		;SAVE STRING POINTER
 	JR	NZ,CMDEND	;NEXT IF NOT THE SAME
 	INC	HL		;POINT TO 2'ND BYTE
 PARLP1	LD	A,(DE)		;TABLE BYTE
 	BIT	7,A		;NEW COMMAND ?
 	JR	NZ,CMDEN	;END OF COMMAND WORD
 	LD	A,(HL)		;STRING BYTE
 	CP	2CH		;TERMINATOR ?
 	JR	Z,CMDEND	;END OF WORD
 	CP	';'
 	JR	Z,CMDEND
 	CP	21H		;SPACE OR LESS
 	JR	C,CMDEND	;END OF REG WORD
 	LD	A,(DE)		;TABLE BYTE BACK
 	LD	C,(HL)		;GET STRING BYTE
 	CP	C		;MATCH ?
 	JR	Z,PARM1		;UPPERCASE MATCH
 	RES	5,C		;LOWERCASE OFF
 	CP	C		;SAME ?
 	JR	NZ,CMDEND	;NO MATCH IF NZ
 PARM1	INC	DE		;BUMP POINTERS
 	INC	HL
 	JR	PARLP1
 CMDEN	LD	A,(HL)		;SEE IF HL TERMINATOR TOO
 	CP	2CH		;COMMA ?
 	JR	Z,CMDINC	;HAVE COMMAND
 	CP	';'
 	JR	Z,HAVCNT
 	CP	21H		;SPACE OR LESS ?
 	JR	C,CMDHAV	;HAVE COMMAND
 CMDEND	POP	HL		;RESTORE HL
 	INC	B		;INCREMENT COUNT
 	JR	PARLP		;CONTINUE THROUGH STRING
 CMDHAV	CP	20H		;SPACE ?
 	JR	C,HAVCNT	;DON'T INCREMENT IF NOT
 CMDINC	INC	HL		;HL=>TERMINATOR +1
 HAVCNT	LD	A,B		;GET TABLE POSITION
 	OR	A		;SET NZ FLAG
 	EX	(SP),HL		;SAVE CURRENT HL
 	POP	HL		;RESTORE STACK
 PAREND	POP	BC		;RESTORE BC
 	RET			;DONE, A=POSITION
 ;  FOLLOWING IS THE ACTIVE SYSTEM TABLE
 ;  FIRST BYTE = 0 IF NONACTIVE
 ;  SECOND BYTE = START TRACK OF SYS FILE
 ;  THIRD BYTE = START SECTOR OF SYS FILE
 SYSTBL	DB	0,0,0,0		;SYS1
 	DB	0,0,0,0		;SYS2
 	DB	0,0,0,0		;SYS3
 	DB	0,0,0,0		;SYS4
 	DB	0,0,0,0		;SYS5
 	DB	0,0,0,0		;SYS6
 	DB	0,0,0,0		;SYS7
 	DB	0,0,0,0		;SYS8
 	DB	0,0,0,0		;SYS9
 	DB	0,0,0,0		;SYS10
 	DB	0,0,0,0		;SYS11
 	DB	0,0,0,0		;SYS12
 	DB	0,0,0,0		;SYS13
 	DB	0,0,0,0		;SYS14
 	DB	0,0,0,0		;SYS15
 MREAD	PUSH	AF		;SAVE COUNT
 	CALL	READ		;READ THE SECTOR
 	JP	NZ,ERROR	;READ ERROR
 	POP	AF		;RESTORE COUNT
 	DEC	A		;LESS 1
 	RET	Z		;DONE
 	CALL	NEXSEC		;ADVANCE DE TO NEXT SEC.
 	JR	MREAD		;CONTINUE
 NOTHIN	LD	HL,NOTHING
 	CALL	PRINT
 	JP	READY
 NOTHING	DB	'Nothing Done.',3
 RDY	DB	10,'OK',13
 SYSERR	DB	'System Program NOT ACTIVE.',13
 NOSYS	LD	HL,SYSERR
 	CALL	PRINT
 	JP	READY
 ERROR	LD	(ERCODE),A	;SAVE ERROR CODE
 	LD	A,41H		;SYS 4, COMMAND 1
 	RST	28H		;PRINT MESSAGE
 	JP	READY		;FINISHED
 GODOS	PUSH	HL
 	PUSH	DE
 	PUSH	AF
 	AND	0F0H
 	JR	Z,GOSYS0	;JUMP TO SYS0
 	LD	HL,4E00H	;JUMP TABLE
 SYS0C	POP	AF		;GET COMMAND
 	AND	0FH		;MASK HIGH BITS
 	DEC	A		;ADJUST FOR TABLE
 	SLA	A		;* 2 BYTE COMMAND
 	ADD	A,L		;POINT TO ENTRY
 	LD	L,A
 	LD	E,(HL)		;GET LSB
 	INC	HL
 	LD	D,(HL)		;GET MSB
 	EX	DE,HL		;HL=ADDRESS
 	POP	DE		;RESTORE DE
 	EX	(SP),HL		;RESTORE HL
 	RET			;GO LIBRARY COMMAND
 PAUSE	PUSH	AF		;SAVE CHAR
 	CALL	INKEY		;GET A KEY
 	CP	40H		;SH @ ?
 	JR	Z,PAUWT
 	CP	60H
 	JR	NZ,PAURET
 PAUWT	LD	A,(4018H)	;GET KEY CHAR
 	LD	(CHSAV),A	;SAVE IT
 	LD	A,2
 	LD	(4018H),A
 PAUHLD	CALL	INKEY		;WAIT FOR NEXT KEY
 	JR	Z,PAUHLD
 	LD	A,(CHSAV)
 	LD	(4018H),A
 PAURET	POP	AF		;GET CHAR BACK
 	RET			;DONE
 GOSYS0	LD	HL,4E20H	;SYS0 TABLE
 	JR	SYS0C		;CONTINUE
 POSHL	LD	A,(HL)
 	CP	13		;TERMINATOR ?
 	JR	Z,POSHL1
 	CP	';'
 	JR	Z,POSHL1
 	CP	','
 	JR	Z,POSHL3
 	CP	20H
 	JR	NZ,POSHL2
 POSHL3	INC	HL
 	JR	POSHL
 POSHL1	SCF
 	RET
 POSHL2	SCF
 	CCF
 	RET
 NEXSEC	CALL	GETTYP		;GET DRIVE TYPE
 	LD	L,0AH		;10 SECTOR FOR SINGLE DEN
 	BIT	7,A		;IF SINGLE
 	JR	Z,SECEND	;HAVE COUNT
 	LD	L,18		;18 INSTEAD
 SECEND	INC	E		;BUMP SECTOR
 	LD	A,E		;GET IT
 	SUB	L		;LESS SECTOR COUNT
 	RET	NZ		;NOT AT END YET
 	LD	E,A		;E=0
 	INC	D		;BUMP TRACK
 	RET			;DONE
 PARCHK	RST	8		;POSITION HL
 	RET	C		;TERMINATOR
 	LD	DE,PARCMD	;PARSE COMMANDS
 	RST	18H		;SKIP THROUGH THEM
 	RET	NZ		;NOT IN LIST
 	JR	PARCHK		;GO AGAIN
 PARCMD	DB	'T'+80H,'O'
 	DB	'F'+80H,'ROM'
 	DB	'O'+80H,'VER'
 	DB	'U'+80H,'SING'
 	DB	80H
 	END
R
 	LD	DE,PARCMD	;PARSE COMMANDS
 	RST	18H		;SKIP THROUGH THEM
 	RET	NZ		;NOT IN LIST
 	JR	PARCHK		;GO AGAIN
 PARCMD	DB	'T'+80H,'O'
 	DB	'F'+80H,'ROM'
 	DB	'O'+80H