S4000/ 	ORG	4000H
 ;	S4000/ASM
 ;
 ;  CONTAINS ALL RESERVED RAM SPACE
 COMST	EQU	37DEH	;COMMUNICATION STATUS
 COMDAT	EQU	37DFH	;COMMUNICATION DATA
 ILATCH	EQU	37E0H	;INTERRUPT LATCH
 DDSEL	EQU	37E1H	;DISK DRIVE SELECT
 CASEL	EQU	37E4H	;CASSETTE SELECT
 LPRT	EQU	37E8H	;LINEPRINTER
 FDC	EQU	37ECH	;FLOPPY-DISK CONTROLLER
 TRACK	EQU	37EDH	;FDC TRACK REGISTER
 SECTOR	EQU	37EEH	;FDC SECTOR REGISTER
 STATUS	EQU	37EFH	;FDC STATUS & TRACK SEEK REGISTER
 RST8	JP	POSHL		;MOVE HL =>
 RST10H	JP	POSPARAM	;MOVE HL =>
 RST18H	JP	PARSE		;COMPARE STRING TO TABLE
 RST20H	JP	PARCHK		;CHECK FOR PARAMETERS
 RST28H	JP	OVERLAY		;BRING IN OVERLAY & JUMP
 RST30H	JP	0
 RST38H	JP	TASK		;INTERRUPT SERVICE ROUTINE
 ;
 ;	CONTROL BLOCKS SET AS FOLLOWS
 ;  DCB TYPE = 0 IF NON-ACTIVE
 ;  DCB TYPE = 1 ACTIVE OUTPUT, -1 ACTIVE INPUT
 ;  DCB TYPE = * IF ACTIVE AND SET TO ANOTHER BLOCK
 ;  ADDRESS  = 2 BYTE DRIVER ADDRESS
 ;  ADDRESS  = DEVICE NAME IF DCB TYPE = *
 ;
 ;	KEYBOARD DEVICE CONTROL BLOCK
 KIDCB	DB	0FFH	;KEYBOARD DCB TYPE, INPUT
 KIADDR	DW	KEYIN	;DRIVER ADDRESS
 KIFLAG	DB	0	;KEYBOARD STATUS FLAG
 ;BIT 7 = GRAPHICS OFF/ON
 ;BIT 6 =
 ;BIT 5 =
 ;BIT 4 =
 ;BIT 3 =
 ;BIT 2 =
 ;BIT 1 = AUTO REPEAT OFF/ON
 ;BIT 0 = UPPER/LOWER CASE
 KICOUNT	DB	12H	;DELAY TIME B4 1'ST REPEAT
 RPCOUNT	DB	0	;DELAY COUNTER
 	DM	'KI'	;DEVICE NAME
 ;	DISPLAY DEVICE CONTROL BLOCK
 DODCB	DB	1	;DISPLAY DCB TYPE, OUTPUT
 DOADDR	DW	VOUT	;DRIVER ADDRESS
 CURSOR	DW	3C00H	;CURSOR POSITION
 CHAR	DB	'['	;CURSOR CHARACTER
 	DM	'DO'	;DEVICE NAME
 ;	PRINTER DEVICE CONTROL BLOCK
 PRDCB	DB	1	;PRINTER DCB TYPE,OUTPUT
 PRADD	DW	POUT	;DRIVER ADDRESS
 LINEPG	DB	67	;LINES/PAGE
 COUNT	DB	0	;LINE COUNTER
 PRFLAG	DB	0	;PRINTER CONDITION
 ;BIT 7 = WILL PRINT GRAPHICS
 ;BIT 6 =
 ;BIT 5 =
 ;BIT 4 =
 ;BIT 3 =
 ;BIT 2 =
 ;BIT 1 =
 ;BIT 0 =
 	DM	'PR'	;DEVICE NAME
 	JP	READY		;GO DOS READY
 	JP	NONDOS		;NON DOS ERROR EXIT
 	JP	LATER		;USE LATER
 KYBRD	DW	0	;KEYBOARD WORK AREA
 	DW	0	; FOR 7 BYTES
 	DW	0	;  "
 	DB	0	;  "
 PSIZE	DB	0	;PRINT SIZE FLAG 0=64, 8=32
 	DB	1	;RELEASE NUMBER
 	DB	0	;WASTER
 ;	TIME STORAGE AREA
 TICKS	DB	0	;COUNT TO 40 FOR 1 SECOND
 SECOND	DB	0	;SECONDS
 MINUTE	DB	0	;MINUTES
 HOUR	DB	0	;HOURS
 YEAR	DB	0	;YEAR
 DAY	DB	0	;DAY
 MONTH	DB	0	;MONTH
 	DW	0	;BEGIN BASIC
 TOPMEM	DW	0	;TOP OF AVAILABLE MEMORY
 VIDTOP	DW	0	;TOP OF VIDEO
 VIDBOT	DW	0	;BOTTOM OF VIDEO
 VFLAG	DB	0	;VIDEO FLAG
 LAST	DB	10H	;LAST DOS COMMAND
 LSTMSK	DB	0	;LAST KEY MASK
 	DS	60	;UNKNOWN	OK
 ;	NEED 4080 UP
 USR	DW	0	;ENTRY TO USR ROUTINE USE
 	DS	3	;UNKNOWN
 INP	DB	0	;INPUT BYTE FROM PORT
 PORT1	DW	0	;PORT NUMBER
 PRTOUT	DB	0	;OUTPUT BYTE TO PORT
 PORT2	DW	0	;PORT NUMBER
 INKEYS	DB	0	;INKEY STORAGE
 ERCODE	DB	0	;ERROR CODE
 CARPOS	DB	0	;PRINTER CARRIAGE POSITION
 ;	DEVICE TYPES AS FOLLOWS
 ;  80 = CASSETTE
 ;   0 = VIDEO
 ;   1 = LINEPRINTER
 ;   2 = DISK DRIVE
 DTF	DB	0	;DEVICE TYPE FLAG
 VAROUT	DB	0	;VARIABLE TO BE OUTPUT
 	DW	0	;UNKNOWN
 STRSPC	DW	0	;STRING SPACE START POINTER
 CLIN	DW	0	;CURRENT LINE BEING PROCESSED
 BASPNT	DW	0	;START OF BASIC PROG. POINTER
 TABPNT	DB	0	;OLD CURSOR POSITION FOR BACK TAB
 BUFPNT	DW	0	;INPUT BUFFER POINTER
 	DB	0	;UNKNOWN
 LSBRND	DB	0	;LSB FOR RANDOM
 LS1RND	DB	0	;LSB FOR RANDOM
 MSBRND	DB	0	;MSB FOR RANDOM
 	DB	0	;UNKNOWN
 FBDIM	DB	0	;FLAG BYTE FOR DIM
 ;	NUMBER TYPE FLAG AS FOLLOWS
 ;  0 = EMPTY
 ;  2 = INTEGER
 ;  3 = STRING
 ;  4 = SINGLE PRECISION
 ;  8 = DOUBLE PRECISION
 NTF	DB	0	;NUMBER TYPE FLAG
 COMPF	DB	0	;COMPRESSOR FLAG FOR 1BC0H
 TOPBAS	DW	0	;TOP OF BASIC POINTER
 STRWRK	DW	0	;STRING WORK AREA POINTER
 STLENG	DB	0	;STRING LENGTH
 STADD	DW	0	;ADDRESS OF STRING/NEXT STRING
 WRKAR	DS	30	;STRING WORK AREA
 MEMSIZ	DW	0	;MEMORY SIZE
 CCM	DW	0	;COMMA CONTROL FOR ?USING
 	DW	0	;UNKNOWN
 DIMUSE	DW	0	;DIMENSION USE
 PUSING	DB	0	;PRINT USING USE
 TENTRY	DW	0	;ENTRY POINT FOR SYSTEM TAPES
 AUTOFL	DB	0	;AUTO FLAG 0 = OFF, 1 = ON
 LINENO	DW	0	;CURRENT LINE NUMBER
 INCREM	DW	0	;AUTO INCREMENT SIZE
 STMT	DW	0	;ENCODED STATEMENT POINTER
 STKPTR	DW	0	;STACK POINTER POINTER
 RESUME	DW	0	;USE FOR RESUME
 EDIT	DW	0	;EDIT LINE NUMBER
 RESUM2	DW	0	;USED FOR RESUME
 ONERR	DW	0		;ON ERROR GOTO POINTER
 ERRSTA	DB	0	;ERROR STATUS
 COLPNT	DW	0	;MIDDLE LINE POINTER
 LASTLN	DW	0	;LAST LINE # EXECUTED
 CONT	DW	0	;USED FOR CONTINUE
 VARPTR	DW	0	;SIMPLE VARIABLE POINTER
 ARRAY	DW	0	;ARRAY POINTER
 FREE	DW	0	;FREE SPACE POINTER
 DATPNT	DW	0	;DATA POINTER
 VARTBL	DS	26	;VARIABLE TYPE DECLARATION TABLE
 TRON	DB	0	;TRACE FLAG. 0=OFF, NZ=ON
 	DB	0	;UNKNOWN
 ARITH	DW	0	;FLOATING POINT ACCUMULATOR 1
 	DW	0	;	"
 	DW	0	;	"
 	DW	0	;	"
 SIGNB1	DB	0	;SIGN BYTE #1
 	DB	0	;UNKNOWN
 ARIHEX	DW	0	;FLOATING POINT ACCUMULATOR 2
 	DW	0	;	"
 	DW	0	;	"
 	DW	0	;	"
 SIGNB2	DB	0	;SIGN BYTE #2
 LINWPT	DW	0	;LINE NUMBER WORK AREA POINTER
 LINWRK	DS	32	;LINE NUMBER WORK AREA
 ;
 ;	DOS INTERCEPT POINTS
 ;
 	JP	CVI
 	JP	FN
 	JP	CVS
 	JP	DEF
 	JP	CVD
 	JP	EOF
 	JP	LOC
 	JP	LOF
 	JP	MKI
 	JP	MKS
 	JP	MKD
 	JP	CMD
 	JP	TIME
 	JP	OPEN
 	JP	FIELD
 	JP	GET
 	JP	PUT
 	JP	CLOSE
 	JP	LOAD
 	JP	MERGE
 	JP	NAME
 	JP	KILL
 	JP	AND	;&
 	JP	LSET
 	JP	RSET
 	JP	INSTR
 	JP	SAVE
 	JP	LINE
 INBUF	DS	6	;INPUT FOR DISK I/O
 	DS	78	;STACK AREA
 STACK	DW	0	;STACK START AREA
 	DS	4	;PREVENT UNDERFLOW
 DOSBUF	DB	0	;I/O BUFFER
 	DS	255	; FOR 256 BYTES
 	END
 	JP	RSET
 	JP	INSTR
 	JP	SAVE
 	JP	LINE
 INBUF	DS	6	;INPUT FOR DISK I/O
 	DS	78	;STACK AREA
 STEVENT UNDERFLOW
 DOSBUF	DEFB	0	;I/O BUFFER
 	DEFS	255	; FOR 256 BYTES
 	END
 	JP	INSTR
 	JP	SAVE
 	J